<?php
/* Autor...:  */
/* Esquema.: PR_AccesoRestriccion.xml */
/* Generado: 2020-08-18 04:21:29 */

/* Metodos de acceso a los campos de la tabla PR_AccesoRestriccion */
abstract class BasePR_AccesoRestriccionBN
{
    /* Campos de la tabla */
    private $i_IdPrAccRes;    // IdPrAccRes: ( no definido )
    private $s_IdPrGrupo;    // IdPrGrupo: ( no definido )
    private $s_Tipo;    // Tipo: ( no definido )
    private $s_TipoCondicion;    // TipoCondicion: ( no definido )
    private $s_Valor;    // Valor: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )

    /* Establece el valor del campo IdPrAccRes */
    public function setIdPrAccRes( $i_IdPrAccRes )
    {
        $this->i_IdPrAccRes = $i_IdPrAccRes;
    }

    /* Obtiene el valor del campo IdPrAccRes */
    public function getIdPrAccRes()
    {
        return $this->i_IdPrAccRes;
    }

    /* Establece el valor del campo IdPrGrupo */
    public function setIdPrGrupo( $s_IdPrGrupo )
    {
        $this->s_IdPrGrupo = $s_IdPrGrupo;
    }

    /* Obtiene el valor del campo IdPrGrupo */
    public function getIdPrGrupo()
    {
        return $this->s_IdPrGrupo;
    }

    /* Establece el valor del campo Tipo */
    public function setTipo( $s_Tipo )
    {
        $this->s_Tipo = $s_Tipo;
    }

    /* Obtiene el valor del campo Tipo */
    public function getTipo()
    {
        return $this->s_Tipo;
    }

    /* Establece el valor del campo TipoCondicion */
    public function setTipoCondicion( $s_TipoCondicion )
    {
        $this->s_TipoCondicion = $s_TipoCondicion;
    }

    /* Obtiene el valor del campo TipoCondicion */
    public function getTipoCondicion()
    {
        return $this->s_TipoCondicion;
    }

    /* Establece el valor del campo Valor */
    public function setValor( $s_Valor )
    {
        $this->s_Valor = $s_Valor;
    }

    /* Obtiene el valor del campo Valor */
    public function getValor()
    {
        return $this->s_Valor;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdPrAccRes' => $this->getIdPrAccRes(),
            'IdPrGrupo' => $this->getIdPrGrupo(),
            'Tipo' => $this->getTipo(),
            'TipoCondicion' => $this->getTipoCondicion(),
            'Valor' => $this->getValor(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaCreacion' => $this->getFechaCreacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto PR_AccesoRestriccionBN desde un RecordSet */
    public static function retrieveByRs( $o_PR_AccesoRestriccionRs )
    {
        $o_PR_AccesoRestriccionBN = new PR_AccesoRestriccionBN();
        $o_PR_AccesoRestriccionBN->setIdPrAccRes( ( integer ) $o_PR_AccesoRestriccionRs[ "IdPrAccRes" ] );
        $o_PR_AccesoRestriccionBN->setIdPrGrupo( $o_PR_AccesoRestriccionRs[ "IdPrGrupo" ] );
        $o_PR_AccesoRestriccionBN->setTipo( $o_PR_AccesoRestriccionRs[ "Tipo" ] );
        $o_PR_AccesoRestriccionBN->setTipoCondicion( $o_PR_AccesoRestriccionRs[ "TipoCondicion" ] );
        $o_PR_AccesoRestriccionBN->setValor( $o_PR_AccesoRestriccionRs[ "Valor" ] );
        $o_PR_AccesoRestriccionBN->setUsuarioCreacion( $o_PR_AccesoRestriccionRs[ "UsuarioCreacion" ] );
        $o_PR_AccesoRestriccionBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_PR_AccesoRestriccionRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        return $o_PR_AccesoRestriccionBN;
    }
}
?>